﻿Type=Service
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@



Sub Process_Globals

	Private serial As Serial
	Private admin As BluetoothAdmin
	Public ast As AsyncStreamsText
	Public connected As Boolean
	Public connecting As Boolean
	Private bc As ByteConverter
End Sub

Sub Service_Create
	serial.Initialize("serial")
	admin.Initialize("admin")
	Connect
End Sub

Public Sub Connect
	admin.StartDiscovery
	connecting = True
	CallSub(Main, "SetState")
End Sub

Private Sub admin_DeviceFound (Name As String, MacAddress As String)
	Log($"Device found: ${Name}"$)
	If Name = "HC-06" Then
		Log("Trying to connect...")
		admin.CancelDiscovery
		serial.Connect(MacAddress)
	End If
End Sub

Private Sub admin_DiscoveryFinished
	connecting = False
'	Log("finished")
End Sub

Private Sub Serial_Connected (Success As Boolean)
	If Success Then
		If ast.IsInitialized Then ast.Close
		ast.Initialize(Me, "Ast", serial.InputStream, serial.OutputStream)
		Log("Connected")
		connected = True
'		SendMessage("connected".GetBytes("UTF8"))
	Else
		Log(LastException)
	End If
	connecting = False
	CallSub(Main, "SetState")
End Sub
Public Sub SendMessage(msg() As Byte)
	ast.astreams.Write(msg)
End Sub

Private Sub ast_NewText (Text As String)
	Private payload() As Byte = bc.StringToBytes(Text,"UTF8")
	Dim tmpbuf(payload.Length -1) As Byte
	bc.ArrayCopy(payload, 1, tmpbuf, 0, payload.Length -1)
	If payload(0) = 116 Then
		CallSub2(Main,"Set_time",tmpbuf)
'		Log("settime")
	Else
		CallSub2(Main,"current",tmpbuf)
'		Log("         current")
	End If
	
'	CallSub2(Main, "MessageFromDevice", Text)
End Sub

Private Sub ast_Terminated
	connected = False
	CallSub(Main, "SetState")
End Sub


Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub


